;;; Studio Tecnico Arch. Giuseppe Conte  
;;; via Roma, 28
;;; 72026 - San Pancrazio Salentino (BR) - Italy
;;;
;;; Plugin  : draw-line-trat.scm
;;; Author  : Arch. Giuseppe Conte 
;;; Date    : 08 maggio 2002 -  Florence - Italy
;;; Revision: 19 giugno 2004
;;; 					10 dicembre 2007 update to TinyScheme
;;; Version : 2.4.1
;;; Last version at: http://xoomer.alice.it/lwcon/gimp/script-fu/draw-line-trat.htm
;;; Help guide at  : http://xoomer.alice.it/lwcon/gimp/script-fu/draw-line-trat.htm
;;; Required : Gimp 2.4.1 or last
;;;
;;; Description: 
;;; To draw precise line, line characteristics consist of combinations of dashes and spaces.
;;; -----------------------------------------------------------------------------
;;;
;;; License:
;;; This program is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation; either version 2 of the License, or
;;; (at your option) any later version.
;;; 
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;; 
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

;;; Define the function:

(define (script-fu-draw-line-trat inImage inLayer xa ya lung alfa dt ds)

	;(define ( pigreco (* 4 (atan 1.0))) )
	(let* ( (beta 0)
					(dx 0)
					(dy 0)
					(beta (* alfa (/ 3.141592654 180)))
					(npoint 4)
					(dx (* (+ dt ds) (cos beta)))
					(dy (* (+ dt ds) (sin beta)))
					(dtx 0)
					(dty 0)
					(lx 0)
					(cnt 0)
					(dtx (* dt (cos beta)))
					(dty (* dt (sin beta)))
					(lx (* lung (cos beta)))
					(cnt dx)
				)

	;(gimp-message "Sono qui")
	;(let points (cons-array 4 'double))  
	(define points (make-vector 4 ))  
	
;; calcolo delle coordinate e disegno del primo trattino
    	(gimp-undo-push-group-start inImage)	;start undo level
    						
  		(vector-set! points 0 xa)
  		(vector-set! points 1 ya)
  		(vector-set! points 2 (+ xa dtx))
  		(vector-set! points 3 (+ ya dty))
  			
  		(gimp-pencil inLayer npoint points )
 
;; loop per il disegno dei trattini successivi
  				
	(while (<= cnt lx)
		(begin
						
  		(vector-set! points 0 (+ (vector-ref points 0) dx))
  		(vector-set! points 1 (+ (vector-ref points 1) dy))
  		(vector-set! points 2 (+ (vector-ref points 2) dx))
  		(vector-set! points 3 (+ (vector-ref points 3) dy))
  	       
  		(gimp-pencil inLayer npoint points)

		(set! cnt (+ cnt dx))
		)
	);end while

    (gimp-undo-push-group-end inImage)     ;end undo level			
  	(gimp-displays-flush)
       
       
	);let	
) ;;def


(script-fu-register
 "script-fu-draw-line-trat"
 _"<Image>/_ATG/_Draw/Draw Line _trat"
 "To draw precise line, line characteristics consist of combinations of dashes and spaces."
 "Arch. Giuseppe Conte <http://xoomer.alice.it/lwcon/>"
 "Giuseppe Conte"
 "10 Dicembre 2007 - San Pancrazio Salentino (BR) - Italy"
 "RGB* GRAY* INDEXED*"
 SF-IMAGE "The Image" 0
 SF-DRAWABLE "The Layer" 0
 SF-ADJUSTMENT "X0" '(0 0 9999 1 10 0 1)
 SF-ADJUSTMENT "Y0" '(0 0 9999 1 10 0 1)
 SF-ADJUSTMENT "Lunghezza" '(0 0 9999 1 10 0 1)
 SF-ADJUSTMENT "Inclinazione" '(0 0 9999 1 10 0 1)
 SF-ADJUSTMENT "Trattino" '(1 0 9999 1 10 0 1)
 SF-ADJUSTMENT "Spazio" '(1 0 9999 1 10 0 1)
)
